/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
package jp.co.ntt.lms.installer.lms;

import java.sql.Connection;
import java.util.Properties;
import java.util.logging.Logger;

import jp.co.ntt.lms.installer.core.InstallerException;
import jp.co.ntt.lms.installer.core.InstallerValues;
import jp.co.ntt.lms.installer.util.LoggerUtil;

/**
 * PostgreSQLにデータベース・テーブルを作成するアクション・クラス。
 * @author T.Nishiki
 */
public class CreateDbPostgresAction extends CreateDbAbstractAction {
	/**
	 * ログ出力オブジェクト。
	 */
	private static Logger _logger;

	/**
	 * スタティック・イニシャライザ。
	 */
	static {
		_logger = LoggerUtil.getLogger(CreateDbPostgresAction.class);
	}

	/**
	 * 対応するデータベースの種別を戻します。<br>
	 * @return データベース種別を戻します。
	 */
	protected String getDbCategory() {
		return "2";
	}

	/**
	 * 渡されたクエリー文が無視してよいか判定します。
	 * @param queryLine 判定対象のクエリー一文。
	 * @return &quot;GO&quot;で開始している場合はtrue。
	 */
	protected boolean isIgnoreQuery(String queryLine) {
		return false;
	}

	/**
	 * ユーザとデータベース作成処理。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @throws InstallerException データベースアクセス中に例外が発生した場合。
	 */
	protected void createUserAndDatabase(InstallerValues values)
		throws InstallerException {

		Connection connection = getDbaConnection(values);
		// ユーザ作成、データベース作成の順に実施
		executeQueryType(values, connection, "create.user");
		executeQueryType(values, connection, "create.database");
	}

	/**
	 * データベース管理者がアクセスするデータベース名を取得します。
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return データベース管理者がアクセスするデータベース名。
	 */
	protected String getDbNameForDba(InstallerValues values) {
		// 独自データとして入力したデータベース名を取得して戻す。
		ConfirmDbInitializeValue dbInitializeValue
			= (ConfirmDbInitializeValue)values.getActionValue(
				ConfirmDbInitializeAction.class.getName());
		Properties dbExtendProperties = dbInitializeValue.getExtendProperties();
		String dbName = dbExtendProperties.getProperty(
			"db.extend.postgres.exist.dbname", "");
		return dbName;
	}

	/**
	 * 与えられたクエリー文の置換を行います。
	 * @param values インストーラ共通データオブジェクト。
	 * @param queryLine 変換対象のクエリー文。
	 * @return 置換後のクエリー文。
	 */
	protected String replace(InstallerValues values, String queryLine) {
		// マネージャ設定値
		ManagerInputValue managerValue
			= (ManagerInputValue)values.getActionValue(
				ManagerInputAction.class.getName());
		queryLine = queryLine.replaceAll(
				"%XMS2_USER%", managerValue.getDbUser());
		queryLine = queryLine.replaceAll(
				"%DB_NAME%", managerValue.getDbName());
		queryLine = queryLine.replaceAll(
				"%XMS2_USER_PWD%", managerValue.getDbPassword());
		queryLine = queryLine.replaceAll(
				"%DB_ENCODE%", managerValue.getDbEncode());
		// メール管理者用メールアドレス
		MailInputValue mailValue
			= (MailInputValue)values.getActionValue(
					MailInputAction.class.getName());
		if (mailValue != null) {
			String siteAdministratorMail = mailValue.getSiteAdministratorMail();
			if (siteAdministratorMail != null) {
				siteAdministratorMail = "null";
			}
			else {
				siteAdministratorMail = "'" + siteAdministratorMail + "'";
			}
			queryLine = queryLine.replaceAll(
					"%MAILSITEADMIN%", siteAdministratorMail);
		}
		else {
			queryLine = queryLine.replaceAll(
					"%MAILSITEADMIN%", "null");
		}
		// 変換後の文字列を戻す。
		return queryLine;
	}
}
